<template>
  <v-toolbar-items>
    <v-menu
      bottom
      offset-y
      left
    >
      <template #activator="{ on }">
        <v-btn
          id="user-options"
          text
          v-on="on"
        >
          <v-icon left>
            account_circle
          </v-icon>
          {{ username }} ({{ userRole }})<v-icon>arrow_drop_down</v-icon>
        </v-btn>
      </template>
      <v-list>
        <v-list-item
          v-if="!isStudent"
          @click="showPasswordChangeDialog"
        >
          Change password
        </v-list-item>
        <v-list-item @click.capture.stop="$vuetify.theme.dark = !$vuetify.theme.dark">
          <v-list-item-content>
            <v-list-item-title>
              Dark mode (experimental)
            </v-list-item-title>
          </v-list-item-content>
          <v-list-item-action>
            <v-switch v-model="$vuetify.theme.dark" />
          </v-list-item-action>
        </v-list-item>
        <v-divider class="my-2" />
        <v-list-item @click="logout">
          <v-icon left>
            exit_to_app
          </v-icon>
          Logout
        </v-list-item>
      </v-list>
    </v-menu>
    <component
      :is="displayComponent"
      v-if="displayComponent"
      @hide="hideComponent"
    />
  </v-toolbar-items>
</template>

<script>
import PasswordChangeDialog from '@/components/PasswordChangeDialog'
import { Authentication } from '@/store/modules/authentication'
import { actions } from '@/store/actions'
export default {
  name: 'UserOptions',
  components: { PasswordChangeDialog },
  data () {
    return {
      displayComponent: null,
    }
  },
  computed: {
    isStudent() { return Authentication.isStudent },
    username() { return Authentication.state.user.username },
    userRole() { return Authentication.state.user.role },
  },
  methods: {
    hideComponent () {
      this.displayComponent = null
    },
    logout () {
      actions.logout()
    },
    showPasswordChangeDialog () {
      this.displayComponent = PasswordChangeDialog
    }
  }
}
</script>

<style scoped>

</style>
